﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;
using System.IO;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        XmlDocument document = CreateXmlDocument(TextBox1.Text);

        XmlDataSource1.Data = document.InnerXml;
        XmlDataSource1.XPath = "Root/*";
        XmlDataSource1.EnableCaching = false;

        WebDataTree1.DataSourceID = "XmlDataSource1";
    }

    private XmlDocument CreateXmlDocument(string directoryPath)
    {
        // Create the declaration and the root.
        XmlDocument document = new XmlDocument();
        XmlDeclaration declaration = document.CreateXmlDeclaration("1.0", null, null);
        document.AppendChild(declaration);
        XmlElement root = document.CreateElement("Root");
        document.AppendChild(root);

        DirectoryInfo path = new DirectoryInfo(directoryPath);
        DirectoryInfo[] rootDirectories = path.GetDirectories();
        FileInfo[] rootFiles = path.GetFiles();

        foreach (DirectoryInfo directory in rootDirectories)
        {
            XmlElement element = document.CreateElement("Folder");
            element.SetAttribute("Name", "<strong>" + directory.Name + "</strong>");
            root.AppendChild(element);

            DirectoryInfo subPath = new DirectoryInfo(directory.FullName);
            DirectoryInfo[] subDirectories = subPath.GetDirectories();
            FileInfo[] subFiles = subPath.GetFiles();

            foreach (DirectoryInfo subDirectory in subDirectories)
            {
                XmlElement subElement = document.CreateElement("Folder");
                subElement.SetAttribute("Name", "<strong>" + subDirectory.Name + "</strong>");
                element.AppendChild(subElement);
            }

            foreach (FileInfo subFile in subFiles)
            {
                XmlElement subElement = document.CreateElement("File");
                subElement.SetAttribute("Name", subFile.Name);
                element.AppendChild(subElement);
            }
        }

        foreach (FileInfo file in rootFiles)
        {
            XmlElement element = document.CreateElement("File");
            element.SetAttribute("Name", file.Name);
            root.AppendChild(element);
        }

        return document;
    }
}
